// Global imports
import GetPut::*;
import FIFO::*;
import Vector::*;

// Local imports
import Types::*;
import Parameters::*;

import PLBMasterWires::*;
import BRAMTargetWires::*;
import BRAMInitiatorWires::*;

/* This is the top level interface. We only have wires going to the 
   plb bus and the DSOCM which implements the BRAM interface. 
*/

interface Multiplier;

  interface PLBMasterWires                  plbMasterWires;
  interface BRAMInitiatorWires#(Bit#(14))   bramInitiatorWires;
endinterface

interface MultiplierBackup;

  interface BRAMInitiatorWires#(Bit#(14))   plbBRAMWires;
  interface BRAMInitiatorWires#(Bit#(14))   bramInitiatorWires;
endinterface


interface PLBMaster;
  interface Put#(ComplexWord) wordInput;
  interface Get#(ComplexWord) wordOutput;
  interface Put#(PLBMasterCommand) plbMasterCommandInput;
  interface PLBMasterWires   plbMasterWires;
endinterface

interface PLBMasterBackup;
  interface Put#(ComplexWord) wordInput;
  interface Get#(ComplexWord) wordOutput;
  interface Put#(PLBMasterCommand) plbMasterCommandInput;
  interface BRAMInitiatorWires#(Bit#(14))  plbBRAMWires;
endinterface
  
interface Feeder;

  interface Put#(PPCMessage)  ppcMessageInput;
  interface Get#(Instruction) ppcInstructionOutput;
  interface BRAMInitiatorWires#(Bit#(14))  bramInitiatorWires;

endinterface



