
import Parameters::*;
import Types::*;
import Interfaces::*;

function String showReg (MatrixRegister r);

  case (r)
    A: return "A";
    B: return "B";
    C: return "C";
  endcase

endfunction

function String showFunctionalUnitOp(FunctionalUnitOp f);
  case (f)
    Multiply: return "Multiply";
    Zero: return "Zero";
    MultiplyAddAccumulate: return "MultiplyAddAccumulate";
    MultiplySubAccumulate:return "MultiplySubAccumulate";
    AddAccumulate: return "AddAccumulate";
    SubAccumulate:return "SubAccumulate";
  endcase
endfunction


function Action showInst (Instruction ins);

  case (ins) matches
    tagged ArithmeticInstruction .i:
      $display("ARITH %0b %0b", i.fus, i.op);
    tagged LoadInstruction .i:
      $display("LOAD %0b %s 0x%0h", i.fus, showReg(i.regName), i.addr);
    tagged StoreInstruction .i:
      $display("STORE %0b %s 0x%0h", i.fu, showReg(i.regName), i.addr);
    tagged ForwardInstruction .i:
      $display("FORWARD %0b %s %0b %s", i.fuSrc, showReg(i.regSrc), i.fuDests, showReg(i.regDest));
    tagged SetRowSizeInstruction .sz:
      $display("SetRowSizeInstruction 0x%0h", sz); 
  endcase
  
endfunction

function Action displayInst (Instruction ins);

  case (ins) matches
    tagged ArithmeticInstruction .i:
      $display("ARITH %0b %0b", i.fus, i.op);
    tagged LoadInstruction .i:
      $display("LOAD %0b %s 0x%0h", i.fus, showReg(i.regName), i.addr);
    tagged StoreInstruction .i:
      $display("STORE %0b %s 0x%0h", i.fu, showReg(i.regName), i.addr);
    tagged ForwardInstruction .i:
      $display("FORWARD %0b %s %0b %s", i.fuSrc, showReg(i.regSrc), i.fuDests, showReg(i.regDest));
    tagged SetRowSizeInstruction .sz:
      $display("SetRowSizeInstruction 0x%0h", sz); 
  endcase
  
endfunction

function Tuple2#(Bit#(32), Bit#(32)) splitInst(Instruction i) = split(zeroExtend(pack(i)));
function Instruction fuseInst(Bit#(32) x ,Bit#(32) y) = unpack(truncate({x, y}));


function Bit#(m) oneHot(Bit#(n) x) provisos (Log#(m, n));

   Bit#(m) tmp = 0;
   tmp[x] = 1;
   return tmp;

endfunction

//This can be mapped across Vectors, etc.

function FUNetworkLink getLink(FunctionalUnit#(t) f);
  return f.link;
endfunction

