import RegFile::*;
import GetPut::*;

`include "Common.bsv"


module mkSimpleFeeder (Feeder);

  Reg#(Bit#(16)) counter <- mkReg(0);
  
  RegFile#(Bit#(16), Bit#(64)) prog <- mkRegFileFullLoad("program.hex");
  
  Reg#(Bit#(64)) approxCC <- mkReg(0);
  
  rule countCC (True);
   
    approxCC <= approxCC + 3;
  
  endrule
  
  interface Put ppcMessageInput;
  
    method Action put(PPCMessage msg);
      
      $display("PPC [APPROXIMATE PPC CC: %0d]: Received Message: 0x%h", approxCC, msg);
      
    endmethod
  
  endinterface
  
  
  interface Get ppcInstructionOutput;

    method ActionValue#(Instruction) get() if (prog.sub(counter) != 64'hAAAAAAAAAAAAAAAA);
      debug(feederDebug, $display("SimpleFeeder: feeding instruction[%d]: %h",
                                  counter,
                                  prog.sub(counter)));
 
      counter <= (counter == maxBound) ? counter : counter + 1;
      let b = prog.sub(counter);
      return unpack(truncate(b));
    endmethod

  endinterface

//  interface BRAMTargetWires bramTargetWires   = ?;
  interface BRAMInitatorWires bramInitiatorWires =  ?;

endmodule
