
import CommonTypes::*;

import RegFile::*;

`define FILENAME "test.out"
`define NUM_ENTRIES 16

//Test that the C code output is packing correctly.
//Assumes the C output is in `FILENAME

module mkPackTest ();


  RegFile#(Bit#(8), Bit#(64)) rf <- mkRegFileLoad(`FILENAME, 0, 255);
  
  Reg#(Bit#(8)) count <- mkReg(0);
  
  rule dispContents (True);
  
    count <= count + 1;
    let b = rf.sub(count);
    Instruction ins = unpack(truncate(b));
    displayInst(ins);
    
    if (count == `NUM_ENTRIES)
      $finish(0);
  
  endrule
  
endmodule
